diff -up ./lib/ssl/tls13exthandle.c.mlkem ./lib/ssl/tls13exthandle.c
--- ./lib/ssl/tls13exthandle.c.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/ssl/tls13exthandle.c	2024-10-18 11:20:24.046115737 -0700
@@ -12,6 +12,8 @@
 #include "pk11pub.h"
 #include "ssl3ext.h"
 #include "ssl3exthandle.h"
+#include "sslt.h"
+#include "tls13con.h"
 #include "tls13ech.h"
 #include "tls13exthandle.h"
 #include "tls13psk.h"
@@ -78,32 +80,77 @@ tls13_SizeOfKeyShareEntry(const sslEphem
 
     if (keyPair->kemKeys) {
         PORT_Assert(!keyPair->kemCt);
-        PORT_Assert(keyPair->group->name == ssl_grp_kem_xyber768d00);
+        PORT_Assert(keyPair->group->name == ssl_grp_kem_mlkem768secp256r1 || keyPair->group->name == ssl_grp_kem_mlkem768x25519);
         pubKey = keyPair->kemKeys->pubKey;
         size += pubKey->u.kyber.publicValue.len;
     }
     if (keyPair->kemCt) {
         PORT_Assert(!keyPair->kemKeys);
-        PORT_Assert(keyPair->group->name == ssl_grp_kem_xyber768d00);
+        PORT_Assert(keyPair->group->name == ssl_grp_kem_mlkem768secp256r1 || keyPair->group->name == ssl_grp_kem_mlkem768x25519);
         size += keyPair->kemCt->len;
     }
 
     return size;
 }
 
-SECStatus
-tls13_EncodeKeyShareEntry(sslBuffer *buf, sslEphemeralKeyPair *keyPair)
+static SECStatus
+tls13_WriteMLKEM768Secp256r1KeyExchangeInfo(sslBuffer *buf, sslEphemeralKeyPair *keyPair)
 {
-    SECStatus rv;
-    unsigned int size = tls13_SizeOfKeyShareEntry(keyPair);
+    PORT_Assert(keyPair->group->name == ssl_grp_kem_mlkem768secp256r1);
+    PORT_Assert(keyPair->keys->pubKey->keyType == ecKey);
 
-    rv = sslBuffer_AppendNumber(buf, keyPair->group->name, 2);
-    if (rv != SECSuccess)
+    // Encode the p256 key first, then the Kyber768 key or ciphertext.
+    SECStatus rv;
+    rv = sslBuffer_Append(buf, keyPair->keys->pubKey->u.ec.publicValue.data,
+                          keyPair->keys->pubKey->u.ec.publicValue.len);
+    if (rv != SECSuccess) {
         return rv;
-    rv = sslBuffer_AppendNumber(buf, size - 4, 2);
-    if (rv != SECSuccess)
+    }
+
+    if (keyPair->kemKeys) {
+        PORT_Assert(!keyPair->kemCt);
+        rv = sslBuffer_Append(buf, keyPair->kemKeys->pubKey->u.kyber.publicValue.data, keyPair->kemKeys->pubKey->u.kyber.publicValue.len);
+    } else if (keyPair->kemCt) {
+        rv = sslBuffer_Append(buf, keyPair->kemCt->data, keyPair->kemCt->len);
+    } else {
+        PORT_Assert(0);
+        PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+        rv = SECFailure;
+    }
+    return rv;
+}
+
+static SECStatus
+tls13_WriteMLKEM768X25519KeyExchangeInfo(sslBuffer *buf, sslEphemeralKeyPair *keyPair)
+{
+    PORT_Assert(keyPair->group->name == ssl_grp_kem_mlkem768x25519);
+    PORT_Assert(keyPair->keys->pubKey->keyType == ecKey);
+
+    // Encode the ML-KEM-768 key or ciphertext first, then the X25519 share.
+    SECStatus rv;
+    if (keyPair->kemKeys) {
+        PORT_Assert(!keyPair->kemCt);
+        rv = sslBuffer_Append(buf, keyPair->kemKeys->pubKey->u.kyber.publicValue.data, keyPair->kemKeys->pubKey->u.kyber.publicValue.len);
+    } else if (keyPair->kemCt) {
+        rv = sslBuffer_Append(buf, keyPair->kemCt->data, keyPair->kemCt->len);
+    } else {
+        PORT_Assert(0);
+        PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+        rv = SECFailure;
+    }
+    if (rv != SECSuccess) {
         return rv;
+    }
+
+    rv = sslBuffer_Append(buf, keyPair->keys->pubKey->u.ec.publicValue.data,
+                          keyPair->keys->pubKey->u.ec.publicValue.len);
+    return rv;
+}
 
+static SECStatus
+tls13_WriteKeyExchangeInfo(sslBuffer *buf, sslEphemeralKeyPair *keyPair)
+{
+    SECStatus rv;
     const SECKEYPublicKey *pubKey = keyPair->keys->pubKey;
     switch (pubKey->keyType) {
         case ecKey:
@@ -116,25 +163,40 @@ tls13_EncodeKeyShareEntry(sslBuffer *buf
         default:
             PORT_Assert(0);
             PORT_SetError(SEC_ERROR_LIBRARY_FAILURE);
+            rv = SECFailure;
             break;
     }
 
+    return rv;
+}
+
+SECStatus
+tls13_EncodeKeyShareEntry(sslBuffer *buf, sslEphemeralKeyPair *keyPair)
+{
+    SECStatus rv;
+    unsigned int size = tls13_SizeOfKeyShareEntry(keyPair);
+
+    rv = sslBuffer_AppendNumber(buf, keyPair->group->name, 2);
     if (rv != SECSuccess) {
         return rv;
     }
 
-    if (keyPair->kemKeys) {
-        PORT_Assert(!keyPair->kemCt);
-        PORT_Assert(keyPair->group->name == ssl_grp_kem_xyber768d00);
-        pubKey = keyPair->kemKeys->pubKey;
-        rv = sslBuffer_Append(buf, pubKey->u.kyber.publicValue.data, pubKey->u.kyber.publicValue.len);
-    }
-    if (keyPair->kemCt) {
-        PORT_Assert(!keyPair->kemKeys);
-        PORT_Assert(keyPair->group->name == ssl_grp_kem_xyber768d00);
-        rv = sslBuffer_Append(buf, keyPair->kemCt->data, keyPair->kemCt->len);
+    rv = sslBuffer_AppendNumber(buf, size - 4, 2);
+    if (rv != SECSuccess) {
+        return rv;
     }
 
+    switch (keyPair->group->name) {
+        case ssl_grp_kem_mlkem768x25519:
+            rv = tls13_WriteMLKEM768X25519KeyExchangeInfo(buf, keyPair);
+            break;
+        case ssl_grp_kem_mlkem768secp256r1:
+            rv = tls13_WriteMLKEM768Secp256r1KeyExchangeInfo(buf, keyPair);
+            break;
+        default:
+            rv = tls13_WriteKeyExchangeInfo(buf, keyPair);
+            break;
+    }
     return rv;
 }
 
diff -up ./lib/util/eccutil.h.mlkem ./lib/util/eccutil.h
--- ./lib/util/eccutil.h.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/util/eccutil.h	2024-10-18 11:20:24.046115737 -0700
@@ -6,6 +6,7 @@
 #define _FREEBL_H_
 
 #define X25519_PUBLIC_KEY_BYTES 32U
+#define SECP256_PUBLIC_KEY_BYTES 65U
 
 /* deprecated */
 typedef enum {
diff -up ./lib/util/kyber.h.mlkem ./lib/util/kyber.h
--- ./lib/util/kyber.h.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./lib/util/kyber.h	2024-10-18 11:20:24.047115747 -0700
@@ -27,6 +27,18 @@ typedef enum {
      * the use of a seed in `Kyber_Encapsulate` for testing.
      */
     params_kyber768_round3_test_mode,
+
+    /*
+     * The ML-KEM parameters specified in FIPS 203.
+     * https://csrc.nist.gov/pubs/fips/203/final
+     */
+    params_ml_kem768,
+
+    /*
+     * Identical to params_ml_kem768 except that this parameter set allows
+     * the use of a seed in `Kyber_Encapsulate` for testing.
+     */
+    params_ml_kem768_test_mode,
 } KyberParams;
 
 #endif /* KYBER_UTIL_H */
diff -up ./lib/util/pkcs11n.h.mlkem ./lib/util/pkcs11n.h
--- ./lib/util/pkcs11n.h.mlkem	2024-10-18 11:20:24.002115288 -0700
+++ ./lib/util/pkcs11n.h	2024-10-18 11:20:24.047115747 -0700
@@ -56,6 +56,7 @@
 #define CKK_NSS_CHACHA20 (CKK_NSS + 4)
 
 #define CKK_NSS_KYBER (CKK_NSS + 5)
+#define CKK_NSS_ML_KEM (CKK_NSS + 6)
 
 /*
  * NSS-defined certificate types
@@ -268,6 +269,10 @@
 #define CKM_NSS_KYBER_KEY_PAIR_GEN (CKM_NSS + 45)
 #define CKM_NSS_KYBER (CKM_NSS + 46)
 
+/* ML-KEM */
+#define CKM_NSS_ML_KEM_KEY_PAIR_GEN (CKM_NSS + 48)
+#define CKM_NSS_ML_KEM (CKM_NSS + 49)
+
 /*
  * HISTORICAL:
  * Do not attempt to use these. They are only used by NSS's internal
@@ -290,6 +295,7 @@
 /* Parameter set identifiers */
 #define CKP_NSS (CKM_VENDOR_DEFINED | NSSCK_VENDOR_NSS)
 #define CKP_NSS_KYBER_768_ROUND3 (CKP_NSS + 1)
+#define CKP_NSS_ML_KEM_768 (CKP_NSS + 2)
 
 /* FIPS Indicator defines */
 #define CKS_NSS_UNINITIALIZED 0xffffffffUL
diff -up ./lib/util/secoid.c.mlkem ./lib/util/secoid.c
--- ./lib/util/secoid.c.mlkem	2024-10-18 11:20:24.008115349 -0700
+++ ./lib/util/secoid.c	2024-10-18 11:20:24.047115747 -0700
@@ -644,6 +644,9 @@ CONST_OID curve25519[] = { 0x2B, 0x06, 0
 CONST_OID ed25519PublicKey[] = { 0x2B, 0x65, 0x70 };
 CONST_OID ed25519Signature[] = { 0x2B, 0x65, 0x70 };
 
+/*https://www.rfc-editor.org/rfc/rfc8410#section-3*/
+CONST_OID x25519PublicKey[] = { 0x2b, 0x65, 0x6e };
+
 #define OI(x)                                  \
     {                                          \
         siDEROID, (unsigned char *)x, sizeof x \
@@ -1890,11 +1893,19 @@ const static SECOidData oids[SEC_OID_TOT
     ODE(SEC_OID_RC2_64_CBC, "RC2-64-CBC", CKM_RC2_CBC, INVALID_CERT_EXTENSION),
     ODE(SEC_OID_RC2_128_CBC, "RC2-128-CBC", CKM_RC2_CBC, INVALID_CERT_EXTENSION),
     ODE(SEC_OID_ECDH_KEA, "ECDH", CKM_ECDH1_DERIVE, INVALID_CERT_EXTENSION),
+    OD(x25519PublicKey, SEC_OID_X25519,
+        "X25519 key exchange", CKM_EC_MONTGOMERY_KEY_PAIR_GEN, INVALID_CERT_EXTENSION),
+
+    ODE(SEC_OID_MLKEM768X25519,
+        "ML-KEM-768+X25519 key exchange", CKM_INVALID_MECHANISM, INVALID_CERT_EXTENSION),
+
 
     /* this will change upstream. for now apps shouldn't use it */
     /* we need it for the policy code.  */
     ODE(SEC_OID_PRIVATE_1,
         "TLS Require EMS", CKM_INVALID_MECHANISM, INVALID_CERT_EXTENSION),
+    ODE(SEC_OID_PRIVATE_2,
+        "ML-KEM-768+SECP256 key exchange", CKM_INVALID_MECHANISM, INVALID_CERT_EXTENSION),
 
 };
 
diff -up ./lib/util/secoidt.h.mlkem ./lib/util/secoidt.h
--- ./lib/util/secoidt.h.mlkem	2024-10-18 11:20:24.008115349 -0700
+++ ./lib/util/secoidt.h	2024-10-18 11:20:24.047115747 -0700
@@ -530,9 +530,14 @@ typedef enum {
     SEC_OID_RC2_64_CBC = 385,
     SEC_OID_RC2_128_CBC = 386,
     SEC_OID_ECDH_KEA = 387,
-    /* this will change upstream. for now apps shouldn't use it */
+    SEC_OID_X25519 = 388,
+
+    SEC_OID_MLKEM768X25519 = 389,
+
+    /* these will change upstream. for now apps shouldn't use it */
     /* give it an obscure name here */
-    SEC_OID_PRIVATE_1 = 388,
+    SEC_OID_PRIVATE_1 = 390,
+    SEC_OID_PRIVATE_2 = 391,
 
     SEC_OID_TOTAL
 } SECOidTag;
diff -up ./tests/bogo/bogo.sh.mlkem ./tests/bogo/bogo.sh
--- ./tests/bogo/bogo.sh.mlkem	2024-06-07 09:26:03.000000000 -0700
+++ ./tests/bogo/bogo.sh	2024-10-18 11:20:24.047115747 -0700
@@ -13,7 +13,7 @@
 ########################################################################
 
 # Currently used BorringSSL version
-BOGO_VERSION=f5e0c8f92a22679b0cd8d24d0d670769c1cc07f3
+BOGO_VERSION=73030794f7aaf4f614486b511908841852807936
 
 bogo_init()
 {
